/*
 * adns9800.h
 *
 *  Created on: 30.03.2016
 *      Author: AndreR
 */

#ifndef SRC_HAL_ADNS9800_H_
#define SRC_HAL_ADNS9800_H_

#include "util/spi_sync.h"

typedef struct _ADNS9800Motion
{
	uint8_t motion;
	int16_t deltaX;
	int16_t deltaY;
	uint8_t squal;
	uint8_t pixelSum;
	uint8_t maxPixel;
	uint8_t minPixel;
	uint16_t shutter;
	uint16_t framePeriod;

	int32_t sumX;
	int32_t sumY;

	float speed[2];
} ADNS9800Motion;

typedef struct _ADNS9800
{
	SPISyncSlave slave;

	uint8_t functional;

	ADNS9800Motion motion;

	uint8_t tx[2];
	uint8_t rx[14];
} ADNS9800;

void ADNS9800Init(ADNS9800* pAD, SPISync* pSPI, GPIO_TypeDef* pCSPort, uint32_t csPin);
void ADNS9800UploadFirmware(ADNS9800* pAD);
void ADNS9800SetResolution(ADNS9800* pAD, uint8_t val);
void ADNS9800GetProdRev(ADNS9800* pAD, uint8_t* pProdId, uint8_t* pRevId);
void ADNS9800UpdateMotion(ADNS9800* pAD, float tSample);

#endif /* SRC_HAL_ADNS9800_H_ */
