/*
 * spi4.h
 *
 *  Created on: 31.10.2015
 *      Author: AndreR
 */

#ifndef SPI4_H_
#define SPI4_H_

#include "util/spi_sync.h"
#include "hal/adns9800.h"
#include "log_msgs.h"

#define SPI4_TOUCH_SAMPLES 16

typedef struct _SPI4Global
{
	SPISync bus;

	struct _touch
	{
		SPISyncSlave slave;

		uint32_t sampleTime;

		uint8_t tx[2*2*SPI4_TOUCH_SAMPLES+2];
		uint8_t rx[2*2*SPI4_TOUCH_SAMPLES+2];

		uint8_t pressed;
		uint16_t x;
		uint16_t y;
	} touch;

	ADNS9800 mouse[2];
	uint32_t mouseSampleTime;

	float opticalSpeed[3];

	LogOpticalRaw mouseLog;
} SPI4Global;

extern SPI4Global spi4;

void SPI4Init();
void SPI4Task(void* params);

#endif /* SPI4_H_ */
