/*
 * spi1.h
 *
 *  Created on: 16.10.2015
 *      Author: AndreR
 */

#ifndef SPI1_H_
#define SPI1_H_

#include "util/spi_sync.h"
#include "util/lag_element.h"
#include "ch.h"
#include "log_msgs.h"

#define SPI1_EVENT_QUEUE_SIZE 4

typedef struct _SPI1Global
{
	SPISync bus;
	SPISyncSlave slave;

	mailbox_t eventQueue;
	msg_t eventQueueData[SPI1_EVENT_QUEUE_SIZE];

	uint32_t lastGyrTime;
	uint32_t avgGyrPeriod;

	uint32_t lastAccTime;
	uint32_t avgAccPeriod;

#ifdef DEBUG
	DMA_Stream_TypeDef* pTxDma;
	DMA_Stream_TypeDef* pRxDma;
	SPI_TypeDef* pSPI;
	DMA_TypeDef* pDMA;
#endif
} SPI1Global;

typedef struct _ADNS9800Motion
{
	uint8_t motion;
	int16_t deltaX;
	int16_t deltaY;
	uint8_t squal;
	uint8_t pixelSum;
	uint8_t maxPixel;
	uint8_t minPixel;
	uint16_t shutter;
	uint16_t framePeriod;
} ADNS9800Motion;

extern SPI1Global spi1;

void	SPI1Init();
void	SPI1Task(void* params);

void 	ADNS9800Init();
void ADNS9800GetProdRev(uint8_t* pProdId, uint8_t* pRevId);
void ADNS9800GetMotion(ADNS9800Motion* pMot);
void ADNS9800SetResolution(uint8_t val);

#endif /* SPI1_H_ */
