/*
 * ctrl_motor.h
 *
 *  Created on: 08.03.2013
 *      Author: AndreR
 */

#ifndef CTRL_MOTOR_H_
#define CTRL_MOTOR_H_

#include <main/ctrl.h>
#include "util/trajectory_orient.h"

typedef struct PACKED _CtrlMotorConfigVel
{
	float maxXY;
	float maxW;
	uint8_t overrideBat;
} CtrlMotorConfigVel;

typedef struct _CtrlMotor
{
	float velSetpoint[4];
	arm_matrix_instance_f32 matVelSetpoint;

	float curWheel[4];
	arm_matrix_instance_f32 matCurMotor;

	CtrlMotorConfigVel configVel;
	ConfigFile* pConfigFileVel;
} CtrlMotor;

extern CtrlMotor ctrlMotor;
extern CtrlInstance ctrlMotorInstance;

void CtrlMotorSetVelTarget(float x, float y, float w);
void CtrlMotorSetPosTarget(float x, float y, float w);

#endif /* CTRL_MOTOR_H_ */
