/*
 * sys_time.h
 *
 *  Created on: 09.04.2014
 *      Author: AndreR
 */

#ifndef SYS_TIME_H_
#define SYS_TIME_H_

#include "ch.h"
#include "intercom.h"

#define NTP_OFFSET 2208988800UL

#define NTP_TO_UNIX(ntp) (((uint32_t)ntp)-NTP_OFFSET)
#define UNIX_TO_NTP(unix) (((uint32_t)unix)+NTP_OFFSET)

typedef struct _SysTime
{
	float correction;
	int32_t comOffset;
	uint32_t lastCorrTime;
	uint32_t unixOffset;	// time from 1.1.1900 to start of microcontroller
} SysTimeGlobal;

extern SysTimeGlobal sysTime;

void SysTimeInitCorrection(int32_t transmissionTime);

// microsecond precision, integer arithmetic => fast + recommended
unsigned long SysTimeUSec();
unsigned long SysTimeUSecRaw();	// not synchronized
uint32_t SysTimeUnix();	// takes 12days before overflow occurs

// converts SysTimeUSec to seconds (float)
float SysTime();

// maximum precision, uses floating point arithmetic => slow
float SysTimePrec();

#endif /* SYS_TIME_H_ */
